package org.geotools.coverage;

import org.opengis.referencing.operation.TransformException;

/**
 * Diese Klasse stellt eine Hilfs-Klasse dar, um auf Klassen des Pakets
 * <code>org.geotools.coverage</code> zuzugreifen, die von ausserhalb des
 * Pakets nicht erreichbar sind.
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 * @version 1.0
 */
public class CoverageUtil {
  /**
   * Erzeugt eine neue Instanz von {@link GeophysicsCategory}.
   * @param  inverse {@linkplain Category Ursprungskategorie}.
   * @param  isQuantitative {@code true} wenn die Ursprungskategorie quantitativ ist
   * @throws TransformException wenn die Transformation fehlschlaegt
   */
  public static GeophysicsCategory createGeophysicsCategory(Category inverse, boolean isQuantitative) throws TransformException  {
    return new GeophysicsCategory(inverse,isQuantitative);
  }

}
