/*******************************************************************************
 * Copyright (c) 2009 Martin O. J. Schmitz.
 * 
 * This file is part of the SCHMITZM library - a collection of utility 
 * classes based on Java 1.6, focusing (not only) on Java Swing 
 * and the Geotools library.
 * 
 * The SCHMITZM project is hosted at:
 * http://wald.intevation.org/projects/schmitzm/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License (license.txt)
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * or try this link: http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Martin O. J. Schmitz - initial API and implementation
 *     Stefan A. Krüger - additional utility classes
 ******************************************************************************/
package schmitzm.geotools;

import org.geotools.factory.CommonFactoryFinder;
import org.geotools.filter.FilterFactoryImpl;
import org.opengis.filter.Filter;
import org.opengis.filter.FilterFactory;
import org.opengis.filter.FilterFactory2;

import com.vividsolutions.jts.geom.GeometryFactory;

/**
 * Diese Klasse enthaelt statische Helper-Methoden fuer die Arbeit mit
 * {@link Filter}.
 * 
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a>
 *         (University of Bonn/Germany)
 * 
 * @version 1.01
 * 
 */
public class FilterUtil {
	/** Instanz von {@link FilterFactory}. */
	public static final FilterFactoryImpl FILTER_FAC = (FilterFactoryImpl) CommonFactoryFinder
			.getFilterFactory(null);
	/** Globale Instanz von {@link FilterFactory2} **/
	public static final FilterFactory2 FILTER_FAC2 = CommonFactoryFinder
			.getFilterFactory2(null);
	/** Instanz von {@link GeometryFactory}. */
	public static final GeometryFactory GEOMETRY_FAC = new GeometryFactory();
//
//	/**
//	 * Erzeugt eine Kopie eines Filters
//	 * 
//	 * @param filter
//	 *            ein Filter
//	 * 
//	 *            TODO GT 26 Das wird in Atlas und Schmitzm nicht benötigt. Wir
//	 *            können die Methode als theoretisch einfach mal entfernen..
//	 *            Ansonsten habe ich auch eine Mail auf die gt-user geschickt.
//	 */
//	public static Filter cloneFilter(Filter filter) {
//		DuplicatingFilterVisitor dfv = new DuplicatingFilterVisitor(FILTER_FAC2);
//		Filter newFilter = (Filter) dfv.visit(filter, (Object) null);
//		return newFilter;
//	}
}
