/*******************************************************************************
 * Copyright (c) 2009 Martin O. J. Schmitz.
 * 
 * This file is part of the SCHMITZM library - a collection of utility 
 * classes based on Java 1.6, focusing (not only) on Java Swing 
 * and the Geotools library.
 * 
 * The SCHMITZM project is hosted at:
 * http://wald.intevation.org/projects/schmitzm/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License (license.txt)
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * or try this link: http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Martin O. J. Schmitz - initial API and implementation
 *     Stefan A. Krüger - additional utility classes
 ******************************************************************************/
package schmitzm.geotools.map.event;

import org.geotools.map.MapContext;
import org.geotools.map.event.MapLayerListEvent;
import org.geotools.map.event.MapLayerListListener;

/**
 * Diese Klasse bildet eine Basis-Implementierung von
 * {@link MapLayerListListener org.geotools.map.event.MapLayerListListener}, deren
 * Methoden nichts machen.
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of  Bonn/Germany)
 * @version 1.0
 */
public class MapLayerListAdapter implements MapLayerListListener {
  /**
   * Wird aufgerufen, wenn ein Layer dem {@link MapContext} hinzugefuegt wurde.
   * Macht nichts.
   */
  public void layerAdded(MapLayerListEvent e) {
  }

  /**
   * Wird aufgerufen, wenn sich ein Layer veraendert. Macht nichts.
   */
  public void layerChanged(MapLayerListEvent e) {
  }

  /**
   * Wird aufgerufen, wenn ein Layer in eine andere Ebene verschoben wurde.
   * Macht nichts.
   */
  public void layerMoved(MapLayerListEvent e) {
  }

  /**
   * Wird aufgerufen, wenn ein Layer aus dem {@link MapContext} entfernt wurde.
   * Macht nichts.
   */
  public void layerRemoved(MapLayerListEvent e) {
  }

}
