package schmitzm.swing;

import java.util.Vector;

public interface ParserOperatorsHints {

	/**
	 * Returns a list of operators. The string must be valid operators for the
	 * language.
	 */
    public Vector<String> getOperators();
  
	/**
	 * Returns a String that describes how an operator will appear in the
	 * ComboBox/GUI
	 */
    public String getOperatorTitle(String operator);
    
	/**
	 * Returns a String that describes how an operator will do. Used for tooltips.
	 */
    public String getOperatorDescription(String operator);

	/**
	 * Returns the number of parameters an operator expects in his
	 * bracket-encapsulated parameters.	 
	 */
    public int getOperatorParameterCount(String operator);
}
