/*******************************************************************************
 
 * Copyright (c) 2010 Martin O. J. Schmitz.
 * 
 * This file is part of the SCHMITZM library - a collection of utility 
 * classes based on Java 1.6, focusing (not only) on Java Swing 
 * and the Geotools library.
 * 
 * The SCHMITZM project is hosted at:
 * http://wald.intevation.org/projects/schmitzm/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License (license.txt)
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * or try this link: http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Martin O. J. Schmitz - initial API and implementation
 *     Stefan A. Krüger - additional utility classes
 ******************************************************************************/
package schmitzm.swing.event;

/**
 * This {@link Enum} describes different mouse input types that can be
 * performed.
 */

public enum MouseInputType {

	/** A click has been performed with the left mouse button **/
	LClick,

	/** A click has been performed with the right mouse button **/
	RClick,

	/**
	 * A rectangle is being spanned via dragging with the left mouse button.
	 */
	LDrag,

	/**
	 * A rectangle is being spanned via dragging with the right mouse button.
	 */
	RDrag,
//
//	/**
//	 * A rectangle has been spanned via dragging with the left mouse button.
//	 * Button has been released.
//	 */
//	LWin,
//
//	/**
//	 * A rectangle has been spanned via dragging with the right mouse button.
//	 * Button has been released.
//	 */
//	RWin,

	/** The mouse wheel has been used (in any direction) **/
	Wheel

}
