/*******************************************************************************
 * Copyright (c) 2009 Martin O. J. Schmitz.
 * 
 * This file is part of the SCHMITZM library - a collection of utility 
 * classes based on Java 1.6, focusing (not only) on Java Swing 
 * and the Geotools library.
 * 
 * The SCHMITZM project is hosted at:
 * http://wald.intevation.org/projects/schmitzm/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License (license.txt)
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * or try this link: http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Martin O. J. Schmitz - initial API and implementation
 *     Stefan A. Krüger - additional utility classes
 ******************************************************************************/
//package skrueger.geotools;
//
//import java.awt.Component;
//import java.awt.Window;
//import java.awt.event.WindowAdapter;
//import java.awt.event.WindowEvent;
//import java.beans.PropertyChangeListener;
//import java.util.HashMap;
//
//import javax.swing.JComponent;
//import javax.swing.JDialog;
//
//import org.geotools.map.MapLayer;
//import org.opengis.filter.Filter;
//
//import schmitzm.geotools.feature.AttributeTypeFilter;
//import schmitzm.geotools.gui.FeatureTablePane;
//import schmitzm.geotools.gui.JMapPane;
//import schmitzm.geotools.gui.SelectableFeatureTablePane;
//import schmitzm.swing.SwingUtil;
//import skrueger.geotools.selection.StyledFeatureLayerSelectionModel;
//import skrueger.geotools.selection.StyledLayerSelectionModel;
//import skrueger.geotools.selection.StyledLayerSelectionModelSynchronizer;
//import skrueger.geotools.selection.TableSelectionSynchronizer;
//
///**
// * A dialog to show the attribute table of a vector layer. This class implements
// * a {@link PropertyChangeListener} which is connected to the {@link StyledLayerInterface
// * StyledLayerInterface's} {@link StyledLayerSelectionModel} to keep the table selection
// * synchronized to other component's selection (e.g. Map or chart).
// */
//public class AttributeTableJDialog extends JDialog {
//
//	/** A cache that manages maximum one instance of this class per layer **/
//	private static HashMap<String, AttributeTableJDialog> dialogCache = new HashMap<String, AttributeTableJDialog>();
//
//	private final StyledFeatureCollectionTableModel model;
//
//	private final JMapPane mapPane;
//
//	/** Holds the table and preview of the dialog. */
//	protected FeatureTablePane featureTablePane;
//
//	protected final MapLayer mapLayer;
//
//	private final StyledLayerInterface styledObj;
//
//	private AttributeTableJDialog(Window owner, MapLayer mapLayer,
//			final StyledLayerInterface styledObj, LayerPanel layerPanel) {
//		super(owner);
//		this.styledObj = styledObj;
////		setTitle(RES("AttributeTable.dialog.title", styledObj
////				.getTitle()));
//
//		this.mapLayer = mapLayer;
//
//		this.mapPane = layerPanel.geoMapPane != null ? layerPanel.geoMapPane
//				.getMapPane() : null;
//
//		Filter filter = mapLayer.getQuery() != null ? mapLayer.getQuery()
//				.getFilter() : Filter.INCLUDE;
//
//		// Falsch:
//		// FeatureOperationTreeFilter filter = new
//		// FeatureOperationTreeFilter(dpLayer.getFilterRule());
//
//		if (styledObj instanceof StyledFeatureCollectionInterface) {
//			model = new StyledFeatureCollectionTableModel(
//					(StyledFeatureCollectionInterface) styledObj, filter);
//		} else if (styledObj instanceof StyledFeatureSourceInterface) {
//			model = new StyledFeatureCollectionTableModel(
//					(StyledFeatureSourceInterface) styledObj, filter);
//		} else {
//			throw new IllegalArgumentException("StyledObj must be of StyledFeatureSourceInterface or StyledFeatureCollectionInterface"); 
//		}
//
//		getModel().setAttributeFilter(AttributeTypeFilter.NO_GEOMETRY);
//
//		initialize();
//
//		StyledLayerSelectionModel<?> anySelectionModel = layerPanel
//				.getRememberSelection(mapLayer);
//
//		if ((anySelectionModel instanceof StyledFeatureLayerSelectionModel)) {
//			StyledFeatureLayerSelectionModel selectionModel = (StyledFeatureLayerSelectionModel) anySelectionModel;
//			// create a synchronizer to keep the feature table selection
//			// synchronized with the other components connected to the
//			// DpLayerSelectionModel
//			TableSelectionSynchronizer synchronizer = new TableSelectionSynchronizer(
//					selectionModel, featureTablePane.getTable());
//			selectionModel
//					.addSelectionListener((StyledLayerSelectionModelSynchronizer) synchronizer);
//			featureTablePane.getTable().getSelectionModel()
//					.addListSelectionListener(synchronizer);
//		}
//
//	}
//
//	private void initialize() {
//		featureTablePane = new SelectableFeatureTablePane(getModel(), true,
//				mapPane);
//
//		setContentPane(featureTablePane);
//
//		SwingUtil.centerFrameOnScreenRandom(this);
//
//		pack();
//	}
//
//	public StyledFeatureCollectionTableModel getModel() {
//		return model;
//	}
//
//	/**
//	 * Checks if there exists an open instance of the AtlasAttributeTable and
//	 * disposes it.
//	 * 
//	 * @param layerId
//	 *            A {@link String} id that equals mapLayer.getTitle() and
//	 *            dpLayer.getId()
//	 * @return <code>true</code> if a window has been disposed.
//	 */
//	public static boolean disposeInstanceFor(String layerId) {
//		AttributeTableJDialog atlasAttributeTableJDialog = dialogCache
//				.get(layerId);
//		if (atlasAttributeTableJDialog != null) {
//			atlasAttributeTableJDialog.dispose();
//			dialogCache.remove(layerId);
//			return true;
//		}
//		return false;
//	}
//
//	/**
//	 * This class manages itself, that there is always only one instance for any {@link StyledLayerInterface}
//	 * 
//	 * @param dpLayer
//	 *            The source for the attribute table
//	 * @param owner
//	 *            A {@link JComponent} that is the parent GUI Dialogue
//	 * @param layerPanel
//	 *            May be <code>null</code>
//	 * @param mapLayer
//	 *            If <code>null</code>, then no "ZoomToLayer" button will
//	 *            appear.
//	 */
//	public static AttributeTableJDialog getInstanceFor(Component comp,
//			MapLayer mapLayer, final StyledLayerInterface<?> styledObj,
//			LayerPanel layerPanel) {
//
//		AttributeTableJDialog atlasAttributeTableJDialog = dialogCache
//				.get(styledObj.getId());
//
//		if (atlasAttributeTableJDialog == null) {
//			Window window = SwingUtil.getParentWindow(comp);
//			atlasAttributeTableJDialog = new AttributeTableJDialog(window,
//					mapLayer, styledObj, layerPanel);
//
//			atlasAttributeTableJDialog.addWindowListener(new WindowAdapter() {
//				@Override
//				public void windowClosing(WindowEvent e) {
//					super.windowClosing(e);
//					dialogCache.remove(styledObj.getId());
//				}
//			});
//
//			dialogCache.put(styledObj.getId(), atlasAttributeTableJDialog);
//		}
//		// Changing the filter is propagated via an Event in AtlaslayerPaneGroup
//		// else {
//		// Filter filter = (mapLayer != null && mapLayer.getQuery() != null) ?
//		// mapLayer
//		// .getQuery().getFilter()
//		// : Filter.INCLUDE;
//		// // Check if the filter has changed...
//		// if (!filter.equals(atlasAttributeTableJDialog.getModel()
//		// .getFilter())) {
//		//
//		// atlasAttributeTableJDialog.getModel().setFilter(filter);
//		// }
//		// }
//
//		return atlasAttributeTableJDialog;
//
//	}
//
//}
