//package skrueger.geotools;
//
//import java.awt.Color;
//import java.awt.Graphics;
//import java.awt.Point;
//import java.awt.Rectangle;
//import java.awt.event.MouseAdapter;
//import java.awt.event.MouseEvent;
//import java.awt.event.MouseWheelEvent;
//
//import org.apache.log4j.Logger;
//
//import schmitzm.swing.SwingUtil;
//
//import com.vividsolutions.jts.geom.Coordinate;
//import com.vividsolutions.jts.geom.Envelope;
//
//public class ZoomXMapPaneMouseListener extends MouseAdapter {
//
//	private static Logger LOGGER = Logger
//			.getLogger(ZoomXMapPaneMouseListener.class);
//
//	protected final XMapPane xMapPane;
//
//	protected boolean enabled = true;
//
//	public ZoomXMapPaneMouseListener(XMapPane xMapPane) {
//		if (xMapPane == null)
//			throw new IllegalArgumentException("xMapPane may not be null");
//		this.xMapPane = xMapPane;
//	}
//
//	/**
//	 * Stores beginning of a drag event in window coordinates
//	 */
//	protected Point startPos;
//
//	/**
//	 * Stores last position of a drag event in window coordinates
//	 */
//	protected Point lastPos;
//
//	/**
//	 * Draws a rectangle in XOR mode from the origin at {@link #startPos} to the
//	 * given point. All in screen coordinates.
//	 */
//	protected void drawRectangle(final Graphics graphics, Point e) {
//		// undraw last box/draw new box
//		final int left = Math.min(startPos.x, e.x);
//		final int right = Math.max(startPos.x, e.x);
//		final int top = Math.max(startPos.y, e.y);
//		final int bottom = Math.min(startPos.y, e.y);
//		final int width = right - left;
//		final int height = top - bottom;
//
//		if (width == 0 && height == 0)
//			return;
//
//		graphics.setXORMode(Color.WHITE);
//		graphics.drawRect(left, bottom, width, height);
//	}
//
//	public void mousePressed(final MouseEvent e) {
//		if (!isEnabled())
//			return;
//		startPos = new Point(e.getPoint());
//		lastPos = new Point(e.getPoint());
//	}
//
//	public void mouseReleased(final MouseEvent e) {
//		if (!isEnabled())
//			return;
//
//		// If this is a click, let mouseClicked handle it!
//		if ((Math.abs(startPos.x - e.getPoint().x) * Math.abs(e.getPoint().y
//				- startPos.y)) < 160) {
//			// xMapPane.zoomTo(e.getPoint(), .5);
//			return;
//		}
//
//		
//		// Not the best check.. but works
//		if (xMapPane.getCursor() == SwingUtil.PANNING_CURSOR)
//		{
//			xMapPane.performPan();
//			return;
//		}
//
//		final Rectangle bounds = xMapPane.getBounds();
//
//		Envelope mapArea = xMapPane.getMapArea();
//
//		// Replace with transform and translate
//		final double mapWidth = mapArea.getWidth();
//		final double mapHeight = mapArea.getHeight();
//
//		final double startX = ((startPos.x * mapWidth) / (double) bounds.width)
//				+ mapArea.getMinX();
//		final double startY = (((bounds.getHeight() - startPos.y) * mapHeight) / (double) bounds.height)
//				+ mapArea.getMinY();
//		final double endX = ((e.getPoint().x * mapWidth) / (double) bounds.width)
//				+ mapArea.getMinX();
//		final double endY = (((bounds.getHeight() - e.getPoint().y) * mapHeight) / (double) bounds.height)
//				+ mapArea.getMinY();
//
//		if (xMapPane.getState() == XMapPane.ZOOM_IN) {
//
//			drawRectangle(xMapPane.getGraphics(), e.getPoint());
//
//			final double left = Math.min(startX, endX);
//			final double right = Math.max(startX, endX);
//			final double bottom = Math.min(startY, endY);
//			final double top = Math.max(startY, endY);
//			final Coordinate ll = new Coordinate(left, bottom);
//			final Coordinate ur = new Coordinate(right, top);
//
//			xMapPane.setMapArea(new Envelope(ll, ur));
//
//		} else if (xMapPane.getState() == XMapPane.ZOOM_OUT) {
//
//			// Remove the rectangle
//			drawRectangle(xMapPane.getGraphics(), e.getPoint());
//			//
//			// // Don't zoom too small areas
//			// if ((Math.abs(startPos.x - e.getPoint().x) * Math
//			// .abs(e.getPoint().y - startPos.y)) < 100) {
//			// xMapPane.zoomTo(e.getPoint(), 2.);
//			// return;
//			// }
//
//			// make the dragged rectangle in screen coords the new map size?
//			final double left = Math.min(startX, endX);
//			final double right = Math.max(startX, endX);
//			final double bottom = Math.min(startY, endY);
//			final double top = Math.max(startY, endY);
//			final double nWidth = (mapWidth * mapWidth) / (right - left);
//			final double nHeight = (mapHeight * mapHeight) / (top - bottom);
//			final double deltaX1 = left - mapArea.getMinX();
//			final double nDeltaX1 = (deltaX1 * nWidth) / mapWidth;
//			final double deltaY1 = bottom - mapArea.getMinY();
//			final double nDeltaY1 = (deltaY1 * nHeight) / mapHeight;
//			final Coordinate ll = new Coordinate(mapArea.getMinX() - nDeltaX1,
//					mapArea.getMinY() - nDeltaY1);
//			final double deltaX2 = mapArea.getMaxX() - right;
//			final double nDeltaX2 = (deltaX2 * nWidth) / mapWidth;
//			final double deltaY2 = mapArea.getMaxY() - top;
//			final double nDeltaY2 = (deltaY2 * nHeight) / mapHeight;
//			final Coordinate ur = new Coordinate(mapArea.getMaxX() + nDeltaX2,
//					mapArea.getMaxY() + nDeltaY2);
//
//			xMapPane.setMapArea(new Envelope(ll, ur));
//		}
//
//	}
//
//	public void setEnabled(boolean enabled) {
//		this.enabled = enabled;
//	}
//
//	/**
//	 * Returns <code>true</code> if the xMapPane is well defined and the
//	 * listener is enabled.
//	 */
//	public boolean isEnabled() {
//		return enabled && xMapPane.isWellDefined();
//	}
//
//	/**
//	 * Verarbeitet die Mausrad-Aktion, indem gezoomed wird.
//	 * 
//	 * @param wheelEvt
//	 *            Mausrad-Event
//	 */
//	public void mouseWheelMoved(MouseWheelEvent wheelEvt) {
//		if (!isEnabled())
//			return;
//		
//		//DONE
//
//		final int units = wheelEvt.getUnitsToScroll();
//		if (units > 0)
//			xMapPane.zoomTo(wheelEvt.getPoint(), 1. + .11 * units);
//		else
//			xMapPane.zoomTo(wheelEvt.getPoint(), 2. / -units);
//	}
//
//	@Override
//	public void mouseClicked(final MouseEvent e) {
//
//		// DONE
//		
//		if (!isEnabled())
//			return;
//
//		int state = xMapPane.getState();
//
//		// Nothing to do for panning
//		if (state == XMapPane.PAN)
//			return;
//
//		if (state == XMapPane.ZOOM_IN && e.getButton() == MouseEvent.BUTTON1) {
//			xMapPane.zoomTo(e.getPoint(), 1 / 2.);
//		} else if (state == XMapPane.ZOOM_IN
//				&& e.getButton() == MouseEvent.BUTTON3
//				|| state == XMapPane.ZOOM_OUT) {
//			xMapPane.zoomTo(e.getPoint(), 2.);
//		}
//
//	}
//
//	/**
//	 * Constantly fired while the mouse is dragging
//	 */
//	public void mouseDragged(final MouseEvent event) {
//		if (!isEnabled())
//			return;
//
//		xMapPane.mouseDragged(startPos, lastPos, event);
//
//		lastPos = event.getPoint();
//	}
//
//}
