/*******************************************************************************
 * Copyright (c) 2009 Martin O. J. Schmitz.
 * 
 * This file is part of the SCHMITZM library - a collection of utility 
 * classes based on Java 1.6, focusing (not only) on Java Swing 
 * and the Geotools library.
 * 
 * The SCHMITZM project is hosted at:
 * http://wald.intevation.org/projects/schmitzm/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License (license.txt)
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * or try this link: http://www.gnu.org/licenses/lgpl.html
 * 
 * Contributors:
 *     Martin O. J. Schmitz - initial API and implementation
 *     Stefan A. Krüger - additional utility classes
 ******************************************************************************/
/** 
 Copyright 2008 Stefan Alfons Krüger 
 
 atlas-framework - This file is part of the Atlas Framework

 This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA

 Diese Bibliothek ist freie Software; Sie dürfen sie unter den Bedingungen der GNU Lesser General Public License, wie von der Free Software Foundation veröffentlicht, weiterverteilen und/oder modifizieren; entweder gemäß Version 2.1 der Lizenz oder (nach Ihrer Option) jeder späteren Version.
 Diese Bibliothek wird in der Hoffnung weiterverbreitet, daß sie nützlich sein wird, jedoch OHNE IRGENDEINE GARANTIE, auch ohne die implizierte Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK. Mehr Details finden Sie in der GNU Lesser General Public License.
 Sie sollten eine Kopie der GNU Lesser General Public License zusammen mit dieser Bibliothek erhalten haben; falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
 **/

package skrueger.geotools.selection;

import org.opengis.feature.simple.SimpleFeature;

import skrueger.geotools.StyledFeatureCollectionInterface;
import skrueger.geotools.StyledFeatureSourceInterface;
import skrueger.geotools.StyledFeaturesInterface;
import skrueger.geotools.StyledLayerInterface;

/**
 * This manager holds a set of {@link SimpleFeature Features} which are <i>selected</i>
 * in a {@link StyledLayerInterface} ({@link StyledFeatureCollectionInterface} or
 * {@link StyledFeatureSourceInterface}).
 * @author <a href="mailto:martin.schmitz@koeln.de">Martin Schmitz</a> (University of Bonn/Germany)
 */
public class StyledFeatureLayerSelectionModel extends StyledLayerSelectionModel<String> {
  /**
   * Creates a new selection model.
   * @param styledLayer styled map the selection is controlled of
   */
  public StyledFeatureLayerSelectionModel(StyledFeaturesInterface styledLayer) {
    super(styledLayer);
  }
  
  
  
//***********  UNUSED STUFF  **************  
  
//	/** A static logger for this class  */
//  private static final Logger LOGGER = Logger.getLogger(StyledFeatureLayerSelectionModel.class);
//  /** Holds the current selection as {@link Style}. */
//  protected Style selectionMapStyle = null;
//  /** Holds the current selection as {@link Filter}. */
//  protected Filter selectionFilter = null;
//  /** Holds the current selection as {@code ChartStyle}.
//   *  TODO: determine an appropriate type for the chart styling. */
//  protected Object selectionChartStyle = null;
//    
//  /**
//   * Creates a new selection model.
//   * @param layer layer to control the selection of
//   */
//  public StyledFeatureLayerSelectionModel() {
//  }
//  
//  /**
//   * Not yet implemented!
//   * Extends the current selection by all features contained by
//   * the specified {@link Envelope}.
//   * @param env defines a bounding box
//   */
//  public void addSelection(Envelope env) {
//    // TODO: implement me!
//    refreshSelection();
//  }
//  
//  /**
//   * Not yet implemented!
//   * Reduces the current selection by all features contained by
//   * the specified {@link Envelope}.
//   * @param env defines a bounding box
//   */
//  public void removeSelection(Envelope env) {
//    // TODO: implement me!
//    refreshSelection(); 
//  }
//
//  /**
//   * Not yet implemented!
//   * Extends the current selection by all features accepted by
//   * the specified {@link Filter}.
//   * @param filter defines some features of the layer
//   * @return {@code true} if selection has changed by calling this method
//   */
//  public boolean addSelection(Filter filter) {
//    // TODO: implement me!
//    refreshSelection();
//    return false;
//  }
//  
//  /**
//   * Not yet implemented!
//   * Removes all features accepted by the specified {@link Filter} from the
//   * selection.
//   * @param filter defines some features of the layer
//   * @return {@code true} if selection has changed by calling this method
//   */
//  public boolean removeSelection(Filter filter) {
//    // TODO: implement me!
//    refreshSelection();
//    return false;
//  }
//
//  /**
//   * Returns a {@link Filter}, which defines the current selection.
//   */
//  public Filter getSelectionAsFilter() {
//    return selectionFilter;
//  }
//
//  /**
//   * Returns a {@link Style}, which highlights the current selection.
//   */
//  public Style getSelectionAsStyle() {
//    return selectionMapStyle;
//  }
//
//  /**
//   * Resets all selection objects with the new selection.
//   */
//  protected void resetSelectionObjects() {
////    resetMapStyle(); // TODO go to mapLayerSync
//    resetFilter();
//    resetChartStyle();
//  }
//  
//
////  
////  /**
////   * Creates a {@link Style} to highlight the current selection.
////   */
////  protected void resetMapStyle() {
////    selectionMapStyle = null;
////    try {
////      if ( selectionFeatures.isEmpty() )
////        selectionMapStyle = getLayer().getStyle();
////      else
////        selectionMapStyle = StylingUtil.createDefaultStyle(getLayer().getGeoObject());
////      
//////      getLayer().setStyle(selectionMapStyle);
////    } catch (Exception e) {
////      LOGGER.error("Error while trying to create a selection style",e);
////    }
////  }
//
//  /**
//   * Creates a {@link Filter} for the current selection.
//   */
//  protected void resetFilter() {
//    // create a filter which accepts all Features contained
//    // in the selection list
//    selectionFilter = new AbstractFilterImpl( FeatureUtil.FILTER_FACTORY ) {
//      public boolean evaluate(Object feature) {
//        if ( feature instanceof SimpleFeature )
//          return evaluate((Filter)feature);
//        return false;
//      }
//      public boolean evaluate(SimpleFeature feature) {
//        return selectionFeatures.contains(feature);
//      }
//    };
//  }
//
//  /**
//   * Not yet implemented!
//   * Creates a {@code ChartStyle} to highlight the current selection.
//   */
//  protected void resetChartStyle() {
//    selectionChartStyle = null;
//    // TODO: define the selectionChartStyle
//  }
}
